Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.table
Interface TableModel

All Known Implementing Classes:
  AbstractTableModel

public abstract interface TableModel

The TableModel interface ispecifies the methods the JTable will use to interrogate a tabular data model.

The JTable can be set up to display any data model which implements the TableModel interface with a couple of lines of code:

`TableModel myData = new MyTableModel(); JTable table = new JTable(myData);`

See Also:
  `JTable`, `AbstractTableModel`

Method Summary
`void` | `addTableModelListener(TableModelListener l)` Add a listener to the list that's notified each time a change to the data model occurs.
`java.lang.Class` | `getColumnClass(int columnIndex)` Returns the lowest common denominator Class in the column.
`int` | `getColumnCount()` Returns the number of columns managed by the data source object.
`java.lang.String` | `getColumnName(int columnIndex)` Returns the name of the column at columnIndex.
`int` | `getRowCount()` Returns the number of records managed by the data source object.
`java.lang.Object` | `getValueAt(int rowIndex, int columnIndex)` Returns an attribute value for the cell at columnIndex and rowIndex.
`boolean` | `isCellEditable(int rowIndex, int columnIndex)` Returns true if the cell at rowIndex and columnIndex is editable.
`void` | `removeTableModelListener(TableModelListener l)` Remove a listener from the list that's notified each time a change to the data model occurs.
`void` | `setValueAt(java.lang.Object aValue, int rowIndex, int columnIndex)` Sets an attribute value for the record in the cell at columnIndex and rowIndex.

Method Detail

### getRowCount

    public int getRowCount()

  Returns the number of records managed by the data source object. A JTable uses this method to determine how many rows it should create and display. This method should be quick, as it is call by JTable quite frequently.
  Returns:
    the number or rows in the model
  See Also:
    `getColumnCount()`

### getColumnCount

    public int getColumnCount()

  Returns the number of columns managed by the data source object. A JTable uses this method to determine how many columns it should create and display on initialization.
  Returns:
    the number or columns in the model
  See Also:
    `getRowCount()`

### getColumnName

    public java.lang.String getColumnName(int columnIndex)

  Returns the name of the column at columnIndex. This is used to initialize the table's column header name. Note, this name does not need to be unique. Two columns on a table can have the same name.
  Parameters:
    `columnIndex` - the index of column
  Returns:
    the name of the column

### getColumnClass

    public java.lang.Class getColumnClass(int columnIndex)

  Returns the lowest common denominator Class in the column. This is used by the table to set up a default renderer and editor for the column.
  Returns:
    the common ancestor class of the object values in the model.

### isCellEditable

    public boolean isCellEditable(int rowIndex,
                                  int columnIndex)

  Returns true if the cell at rowIndex and columnIndex is editable. Otherwise, setValueAt() on the cell will not change the value of that cell.
  Parameters:
    `rowIndex` - the row whose value is to be looked up
    `columnIndex` - the column whose value is to be looked up
  Returns:
    true if the cell is editable.
  See Also:
    `setValueAt(java.lang.Object, int, int)`

### getValueAt

    public java.lang.Object getValueAt(int rowIndex,
                                       int columnIndex)

  Returns an attribute value for the cell at columnIndex and rowIndex.
  Parameters:
    `rowIndex` - the row whose value is to be looked up
    `columnIndex` - the column whose value is to be looked up
  Returns:
    the value Object at the specified cell

### setValueAt

    public void setValueAt(java.lang.Object aValue,
                           int rowIndex,
                           int columnIndex)

  Sets an attribute value for the record in the cell at columnIndex and rowIndex. aValue is the new value.
  Parameters:
    `aValue` - the new value
    `rowIndex` - the row whose value is to be changed
    `columnIndex` - the column whose value is to be changed
  See Also:
    `getValueAt(int, int)`, `isCellEditable(int, int)`

### addTableModelListener

    public void addTableModelListener(TableModelListener l)

  Add a listener to the list that's notified each time a change to the data model occurs.
  Parameters:
    `l` - the TableModelListener

### removeTableModelListener

    public void removeTableModelListener(TableModelListener l)

  Remove a listener from the list that's notified each time a change to the data model occurs.
  Parameters:
    `l` - the TableModelListener

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.